Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.cpp	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.cpp	(revision 1526)
@@ -6,4 +6,5 @@
 using namespace std;
 using namespace Geometry;
+using	namespace	simplif;
 
 #include <gfx/geom/ProxGrid.h>
@@ -13,5 +14,5 @@
 //	Constructor
 //---------------------------------------------------------------------------
-SimplificationMethod::SimplificationMethod(const Mesh *m) 
+SimplificationMethod::SimplificationMethod(const Mesh *m)
 {
 	objmesh							=	m;
@@ -19,4 +20,7 @@
 	first_index_submesh	=	new unsigned int[objmesh->mSubMeshCount];
 	indexMeshLeaves			=	-1;
+
+	//	Create simplification sequence.
+	msimpseq	=	new MeshSimplificationSequence();
 }
 
@@ -41,15 +45,18 @@
 	simplif::vert_info& v1_info = vertex_info(v1);
 
-	simplif::Mat4 Q = v0_info.Q + v1_info.Q;
-	simplif::real norm = v0_info.norm + v1_info.norm;
+	simplif::Mat4 Q 		=	v0_info.Q + v1_info.Q;
+	simplif::real norm	=	v0_info.norm + v1_info.norm;
 
 	auxpair->cost = simplif::quadrix_pair_target(Q, v0, v1, auxpair->candidate);
 
-	if( simplif::will_weight_by_area )
+	if ( simplif::will_weight_by_area )
+	{
 		auxpair->cost /= norm;
-
-	if( simplif::will_preserve_mesh_quality )
+	}
+
+	if ( simplif::will_preserve_mesh_quality )
+	{
 		auxpair->cost += pair_mesh_penalty(M0, v0, v1, auxpair->candidate);
-
+	}
 
 	//
@@ -57,5 +64,5 @@
 	//          the heap is implemented as a MAX heap.
 	//
-	if( auxpair->isInHeap() )
+	if ( auxpair->isInHeap() )
 	{
 		heap->update(auxpair, (float)-auxpair->cost);
@@ -70,19 +77,40 @@
 //	Reasign the new vertex to the adequate face
 //---------------------------------------------------------------------------
-int SimplificationMethod::predict_face(simplif::Face& F, simplif::Vertex *v1, simplif::Vertex *v2, simplif::Vec3& vnew, simplif::Vec3& f1, simplif::Vec3& f2, simplif::Vec3& f3)
+int SimplificationMethod::predict_face(	simplif::Face& F,
+																				simplif::Vertex *v1,
+																				simplif::Vertex *v2,
+																				simplif::Vec3& vnew,
+																				simplif::Vec3& f1,
+																				simplif::Vec3& f2,
+																				simplif::Vec3& f3)
 {
 	int nmapped = 0;
 
 	if( F.vertex(0) == v1 || F.vertex(0) == v2 )
-	{ f1 = vnew;  nmapped++; }
-	else f1 = *F.vertex(0);
+	{
+		f1 = vnew;  nmapped++;
+	}
+	else
+	{
+		f1 = *F.vertex(0);
+	}
 
 	if( F.vertex(1) == v1 || F.vertex(1) == v2 )
-	{ f2 = vnew;  nmapped++; }
-	else f2 = *F.vertex(1);
+	{
+		f2 = vnew;  nmapped++;
+	}
+	else
+	{
+		f2 = *F.vertex(1);
+	}
 
 	if( F.vertex(2) == v1 || F.vertex(2) == v2 )
-	{ f3 = vnew;  nmapped++; }
-	else f3 = *F.vertex(2);
+	{
+		f3 = vnew;  nmapped++;
+	}
+	else
+	{
+		f3 = *F.vertex(2);
+	}
 
 	return nmapped;
@@ -93,7 +121,10 @@
 //---------------------------------------------------------------------------
 //---------------------------------------------------------------------------
-simplif::real SimplificationMethod::pair_mesh_penalty(simplif::Model& M, simplif::Vertex *v1, simplif::Vertex *v2, simplif::Vec3& vnew)
+simplif::real SimplificationMethod::pair_mesh_penalty(simplif::Model& M, simplif::Vertex *v1,
+																		 simplif::Vertex *v2,
+																		 simplif::Vec3& vnew)
 {
 	static simplif::face_buffer changed;
+
 	changed.reset();
 
@@ -103,5 +134,5 @@
 	simplif::real Nmin = 0;
 
-	for(int i=0; i<changed.length(); i++)
+	for (int i	=	0; i < changed.length(); i++)
 	{
 		simplif::Face& F = *changed(i);
@@ -114,7 +145,11 @@
 		{
 			simplif::Plane Pnew(f1, f2, f3);
+
 			simplif::real delta =  Pnew.normal() * F.plane().normal();
 
-			if( Nmin > delta ) Nmin = delta;
+			if( Nmin > delta )
+			{
+				Nmin = delta;
+			}
 		}
 	}
@@ -122,7 +157,11 @@
 	//return (-Nmin) * MESH_INVERSION_PENALTY;
 	if( Nmin < 0.0 )
+	{
 		return MESH_INVERSION_PENALTY;
+	}
 	else
+	{
 		return 0.0;
+	}
 }
 
@@ -130,5 +169,6 @@
 //	Returns true if the givens vertices are a valid pair
 //---------------------------------------------------------------------------
-bool SimplificationMethod::check_for_pair(simplif::Vertex *v0, simplif::Vertex *v1)
+bool SimplificationMethod::check_for_pair(simplif::Vertex *v0,
+																					simplif::Vertex *v1)
 {
 	const simplif::pair_buffer& pairs = vertex_info(v0).pairs;
@@ -137,5 +177,7 @@
 	{
 		if( pairs(i)->v0==v1 || pairs(i)->v1==v1 )
+		{
 			return true;
+		}
 	}
 
@@ -146,5 +188,6 @@
 //	Create a new pair with two given vertices
 //---------------------------------------------------------------------------
-simplif::pair_info *SimplificationMethod::new_pair(simplif::Vertex *v0, simplif::Vertex *v1)
+simplif::pair_info *SimplificationMethod::new_pair(	simplif::Vertex *v0,
+																										simplif::Vertex *v1)
 {
 	simplif::vert_info& v0_info = vertex_info(v0);
@@ -152,4 +195,5 @@
 
 	simplif::pair_info *pair = new simplif::pair_info(v0,v1);
+
 	v0_info.pairs.add(pair);
 	v1_info.pairs.add(pair);
@@ -169,6 +213,8 @@
 	v1_info.pairs.remove(v1_info.pairs.find(auxpair));
 
-	if( auxpair->isInHeap() )
+	if ( auxpair->isInHeap() )
+	{
 		heap->kill(auxpair->getHeapPos());
+	}
 
 	delete auxpair;
@@ -178,54 +224,59 @@
 //	Contract a given pair
 //---------------------------------------------------------------------------
-void SimplificationMethod::do_contract(simplif::Model& m, simplif::pair_info *auxpair)
-{
-	simplif::Vertex *v0 = auxpair->v0;  simplif::Vertex *v1 = auxpair->v1;
+void SimplificationMethod::do_contract(	simplif::Model& m,
+																				simplif::pair_info *auxpair)
+{
+	simplif::Vertex *v0					= auxpair->v0;
+	simplif::Vertex *v1					= auxpair->v1;
 	simplif::vert_info& v0_info = vertex_info(v0);
 	simplif::vert_info& v1_info = vertex_info(v1);
-	simplif::Vec3 vnew = auxpair->candidate;
+	simplif::Vec3 vnew					= auxpair->candidate;
+
 	int i;
+	
+	// V0 must be always the alive vertex
+	// V1 must be always the removed vertex
+	if (vnew == (*v0))
+	{
+		//	Simplification step.
+		simplifstep.mV0 = v0->vID;
+		simplifstep.mV1 = v1->vID;
+	}
+	else
+	{
+		//	Simplification step.
+		simplifstep.mV0 = v1->vID;
+		simplifstep.mV1 = v0->vID;
+		v0->vID = v1->vID;
+	}
 
 	// Make v0 be the new vertex
-	v0_info.Q += v1_info.Q;
-	v0_info.norm += v1_info.norm;
+	v0_info.Q		+= v1_info.Q;
+	v0_info.norm	+= v1_info.norm;
 
 	simplif::Vec3 p(vnew);
-	simplif::Vec3 v0antes(v0->operator[](simplif::X),v0->operator[](simplif::Y),v0->operator[](simplif::Z));
-
-	// Find the edge to remove (before remove it (contract()))
-	simplif::Edge *econ=NULL;
-	bool finded = false;
-	for (i=0; i<v0->edgeUses().length(); i++)
-	{		
-		econ = v0->edgeUses()(i);
-		if (v1->vID == econ->org()->vID || v1->vID == econ->dest()->vID)
-		{
-			finded = true;
-			break;
-		}
-	}
-
-	assert(finded);
-
-
-	// Perform the actual contraction
+/*	simplif::Vec3 v0antes(v0->operator[](simplif::X),
+						  v0->operator[](simplif::Y),
+						  v0->operator[](simplif::Z));*/
+
+	//	Perform the actual contraction.
 	static simplif::face_buffer changed;
+
 	changed.reset();
 	m.contract(v0, v1, vnew, changed);
 
-	// Stores the simplification step
-	MeshSimplificationSequence::Step simplifstep;
-	simplif::Vec3 vdesp = p - v0antes;
-
-	// Stores the displacement in the simplification step
-	simplifstep.x=(float)vdesp[simplif::X];
-	simplifstep.y = (float)vdesp[simplif::Y];
-	simplifstep.z = (float)vdesp[simplif::Z];
-	
-	//	Submeshes which pertains each vertex
-	simplifstep.mV1 = v0->validID(); 
-
-	//	The simplification method returns as v1 the dead vertex.
-	simplifstep.mV0 = v1->validID();
+	std::cout << "Simp seq: " << simplifstep.mV1 << " --> " << simplifstep.mV0 << std::endl;
+
+/*	simplif::Vec3 vdesp = p - v0antes;
+
+	//	Stores the displacement in the simplification step.
+	simplifstep.x	=	(float)vdesp[X];
+	simplifstep.y = (float)vdesp[Y];
+	simplifstep.z = (float)vdesp[Z];*/
+
+	//	Stores the displacement in the simplification step.
+	simplifstep.x =	(float)0.0f;
+	simplifstep.y = (float)0.0f;
+	simplifstep.z = (float)0.0f;
 
 	//	Number of triangles that are removed in this simplification step.
@@ -242,32 +293,36 @@
 	int del_index	=	0;
 
-	// mModfaces y mT0, mT1 of simplifstep stores the triangles id's -> geomesh has not triangles id's
-	for (i=0; i<changed.length(); i++)
-	{
-		simplif::Face *auxface = changed(i);
+	//	Clears faces list.
+	simplifstep.mModfaces.clear();
+
+	//	mModfaces y mT0, mT1 of simplifstep stores 
+	//	the triangles id's -> geomesh has not triangles id's.
+	for (i	=	0;	i < changed.length();	i++)
+	{
+		simplif::Face *auxface	=	changed(i);
 
 		if (auxface->isValid())
 		{
-			// Modified triangles
+			//	Modified triangles.
 			simplifstep.mModfaces.push_back(auxface->validID());
 		}
 		else
 		{
-			// Removed triangles
-			if (_numDelTris==1) 
-			{
-				simplifstep.mT0=auxface->validID();
-				simplifstep.mT1=auxface->validID();
+			//	Removed triangles.
+			if (_numDelTris == 1)
+			{
+				simplifstep.mT0	=	auxface->validID();
+				simplifstep.mT1	=	auxface->validID();
 			}
 			else
 			{
-				if(del_index==0)
+				if(del_index == 0)
 				{
-					simplifstep.mT0=auxface->validID();
+					simplifstep.mT0	=	auxface->validID();
 					del_index++;
 				}
 				else
 				{
-					simplifstep.mT1=auxface->validID();
+					simplifstep.mT1	=	auxface->validID();
 				}
 			}
@@ -275,19 +330,23 @@
 	}
 
-	decim_data.push_back(simplifstep); // Simplification sequence that make reference to the simplification method sequence
+	//	Simplification sequence that make reference to the 
+	//	simplification method sequence.
+	//decim_data.push_back(simplifstep);
+
+	//	Adds new simplification step.
+	msimpseq->mSteps.push_back(simplifstep);
 
 #ifdef SUPPORT_VCOLOR
-	//
-	// If the vertices are colored, color the new vertex
-	// using the average of the old colors.
+	//	If the vertices are colored, color the new vertex
+	//	using the average of the old colors.
 	v0->props->color += v1->props->color;
 	v0->props->color /= 2;
 #endif
 
-	// Remove the pair that we just contracted
+	//	Remove the pair that we just contracted.
 	delete_pair(auxpair);
 
-	// Recalculate pairs associated with v0
-	for(i=0; i<v0_info.pairs.length(); i++)
+	//	Recalculate pairs associated with v0.
+	for (i	=	0;	i < v0_info.pairs.length();	i++)
 	{
 		simplif::pair_info *p = v0_info.pairs(i);
@@ -295,42 +354,60 @@
 	}
 
-	// Process pairs associated with now dead vertex
-	static simplif::pair_buffer condemned(6); // collect condemned pairs for execution
+	//	Process pairs associated with now dead vertex.
+	//	Collect condemned pairs for execution.
+	static simplif::pair_buffer condemned(6);
+
 	condemned.reset();
 
-	for(i=0; i<v1_info.pairs.length(); i++)
+	for (i	=	0;	i < v1_info.pairs.length(); i++)
 	{
 		simplif::pair_info *p = v1_info.pairs(i);
 
 		simplif::Vertex *u;
-		if( p->v0 == v1 )      
+
+		if( p->v0 == v1 )
+		{
 			u = p->v1;
-		else 
-			if( p->v1 == v1)  
+		}
+		else
+		{
+			if( p->v1 == v1)
+			{
 				u = p->v0;
+			}
 			else
+			{
 				std::cerr << "YOW!  This is a bogus pair." << endl;
-
-		if( !check_for_pair(u, v0) )
-		{
-			p->v0 = v0;
-			p->v1 = u;
+			}
+		}
+
+		if ( !check_for_pair(u, v0) )
+		{
+			p->v0	=	v0;
+			p->v1	=	u;
+
 			v0_info.pairs.add(p);
 			compute_pair_info(p);
 		}
 		else
+		{
 			condemned.add(p);
-	}
-
-	for(i=0; i<condemned.length(); i++)
+		}
+	}
+
+	for (i	=	0;	i < condemned.length();	i++)
+	{
 		// Do you have any last requests?
 		delete_pair(condemned(i));
-	v1_info.pairs.reset(); // safety precaution
-
-}
-
-//---------------------------------------------------------------------------
-//---------------------------------------------------------------------------
-bool SimplificationMethod::decimate_quadric(simplif::Vertex *v, simplif::Mat4& Q)
+	}
+
+	//	Safety precaution.
+	v1_info.pairs.reset();
+}
+
+//---------------------------------------------------------------------------
+//---------------------------------------------------------------------------
+bool SimplificationMethod::decimate_quadric(simplif::Vertex *v,
+																						simplif::Mat4& Q)
 {
 	if( vinfo.length() > 0 )
@@ -340,5 +417,7 @@
 	}
 	else
+	{
 		return false;
+	}
 }
 
@@ -347,4 +426,296 @@
 //---------------------------------------------------------------------------
 void SimplificationMethod::decimate_contract(simplif::Model& m)
+{
+	simplif::heap_node	*top;
+	simplif::pair_info	*pair;
+	simplif::Vertex		*v0;
+	simplif::Vertex		*v1;
+	simplif::Vec3		candidate;
+
+	for (;;)
+	{
+		top	=	heap->extract();
+		
+		if (!top)
+		{
+			return;
+		}
+		
+		pair	=	(simplif::pair_info *)top->obj;
+
+		//	Remove all the vertices of the removed edges.
+		bool	sharededge	=	false;
+		
+		for (int	i	=	0;	i < pair->v0->edgeUses().length();	i++)
+		{
+			simplif::Edge	*econ	=	pair->v0->edgeUses()(i);
+			
+			if (pair->v1->vID == econ->org()->vID
+					||
+					pair->v1->vID == econ->dest()->vID)
+			{
+				sharededge	=	true;
+				break;
+			}
+		}
+
+		if (pair->isValid() && sharededge)
+		{
+			break;
+		}
+
+		//	Deletes repetitions of pair in heap.
+		delete_pair(pair);
+	}
+
+	//	Copy pair.
+	v0	=	new Vertex(	pair->v0->operator[](0),
+										pair->v0->operator[](1),
+										pair->v0->operator[](2));
+	v0->uniqID = pair->v0->uniqID;
+	
+	v1	=	new Vertex(	pair->v1->operator[](0),
+										pair->v1->operator[](1),
+										pair->v1->operator[](2));
+
+	v1->uniqID = pair->v1->uniqID;
+
+	candidate	=	pair->candidate;
+
+	//	First contract.
+	simplifstep.obligatory	=	0;
+
+	//	Debug.
+	cout	<<	"Contracting..."	<<	endl;
+
+	//	Contract main pair.
+	do_contract(m, pair);
+
+	//	Twin contract and lonely vertex contract.
+	simplifstep.obligatory	=	1;
+
+	//	Attempt to maintain valid vertex information.
+	M0.validVertCount--;
+
+	//	Find an edge of the same coordinates and different vertex identifiers.
+	removeTwinEdges(m,v0,v1,candidate);
+
+	//	Move vertex of non twin edges.
+	contractLonelyVertices(m,v0,v1,candidate);
+
+	//	Free Memory.
+	delete	v0;
+	delete	v1;
+}
+
+//---------------------------------------------------------------------------
+//	Contract lonely vertex that has the same coords that the contracted one.
+//---------------------------------------------------------------------------
+void	SimplificationMethod::contractLonelyVertices(	simplif::Model	&m,	simplif::Vertex	*v0,
+																			simplif::Vertex	*v1,
+																			simplif::Vec3	candidate)
+{
+	bool				lonely_vertex_found;
+	simplif::Vertex		*vert;
+	simplif::Vertex		*new_vert;
+	simplif::Vertex		*lonely_vert;
+	simplif::Edge		*edge;
+	simplif::heap_node	*top;
+	simplif::pair_info	*pair;
+	simplif::vert_info	new_vert_info;
+	Geometry::GeoVertex	vertex_added;
+	simplif::Vertex		*take_bone_from_vert;
+
+	//	Gets the vertex that is not the candidate.
+	if ((*v0) == candidate)
+	{
+		vert = v1;
+		take_bone_from_vert = v0;
+	}
+	else if ((*v1) == candidate)
+	{
+		vert = v0;
+		take_bone_from_vert = v1;
+	}
+
+	//	For all vertex.
+	for (int	i = 0; i < heap->getSize();	i++)
+	{
+		//	Initialize lonely vertex flag.
+		lonely_vertex_found	=	false;
+
+		//	Gets the current pair.
+		top		=	heap->getElement(i);
+		pair	=	(simplif::pair_info *)top->obj;
+
+		if (pair->v0->isValid() && (*vert) == (*pair->v0))
+		{
+			lonely_vert	=	pair->v0;
+			lonely_vertex_found	=	true;
+		}
+		else if (pair->v1->isValid() && (*vert) == (*pair->v1))
+		{
+			lonely_vert	=	pair->v1;
+			lonely_vertex_found	=	true;
+		}
+
+		//	If a lonely vertex is found. Creates new vertex and contract.
+		if (lonely_vertex_found)
+		{
+			new_vert	=	m.newVertex(candidate[X],candidate[Y],candidate[Z]);	
+			edge		=	m.newEdge(new_vert,lonely_vert);
+
+            // We assume here the there are the same number of vertices and texture coordinates and normals
+
+			// assign a texture coordinate for the vbertex
+			simplif::Vec2 newtexcoord = m.texcoord(lonely_vert->validID());
+			m.in_TexCoord(newtexcoord);
+
+			// assign a normal coordinate for the vbertex
+			simplif::Vec3 newnormal = m.normal(lonely_vert->validID());
+			m.in_Normal(newnormal);
+
+			//	Adds new vertex information to simplification sequence.
+			vertex_added.id			=	new_vert->vID;
+			vertex_added.bonefrom	=	take_bone_from_vert->vID;
+			vertex_added.position	=	Vector3(candidate[X],candidate[Y],candidate[Z]);
+
+			simplif::Vec2 tc = m.texcoord(new_vert->validID());
+			vertex_added.texcoord	=	Vector2(tc[X],tc[Y]);
+
+			simplif::Vec3 vn = m.normal(new_vert->validID());
+			vertex_added.normal		=	Vector3(vn[X],vn[Y],vn[Z]);
+
+			msimpseq->mNewVertices.push_back(vertex_added);
+
+			pair			=	new_pair(new_vert,lonely_vert);
+			pair->candidate	=	candidate;
+
+			pair->notInHeap();
+/*			vinfo(new_vert->validID()).Q		=	vinfo(lonely_vert->validID()).Q;
+			vinfo(new_vert->validID()).norm	=	vinfo(lonely_vert->validID()).norm;*/
+
+			//	Debug.
+			cout	<<	"Contracting new pair..."	<<	endl;
+
+			//	Contract twin pair.
+			do_contract(m, pair);
+			M0.validVertCount--;
+		}
+	}
+}
+
+//---------------------------------------------------------------------------
+//	Find a twin edge of the given one.
+//---------------------------------------------------------------------------
+void SimplificationMethod::removeTwinEdges(	simplif::Model	&m,
+																						simplif::Vertex	*v0,
+																						simplif::Vertex	*v1,
+																						simplif::Vec3		candidate)
+{
+	bool								twin_found;
+	simplif::heap_node	*top;
+	simplif::pair_info	*pair;
+	simplif::Vertex			*aux_vert;
+
+	//	Find a twin edge in heap.
+	for (int	i	=	0;	i < heap->getSize(); i++)
+	{
+		//	Initialize twin flag.
+		twin_found	=	false;
+
+		//	Gets the current pair.
+		top		=	heap->getElement(i);
+		pair	=	(simplif::pair_info *)top->obj;
+
+		if (pair->v0->isValid()==false || pair->v1->isValid()==false)
+			continue; 
+
+		if (v0->operator[](0) == pair->v0->operator[](0)
+				&&
+				v0->operator[](1) == pair->v0->operator[](1)
+				&&
+				v0->operator[](2) == pair->v0->operator[](2))
+		{
+			if (v1->operator[](0) == pair->v1->operator[](0)
+					&&
+					v1->operator[](1) == pair->v1->operator[](1)
+					&&
+					v1->operator[](2) == pair->v1->operator[](2))
+			{
+				//	Debug.
+				cout	<<	"Twin contracted (NO Swap)..."	<<	endl;
+
+				//	Active twin flag.
+				twin_found	= true;
+			}
+		}
+		else
+		{
+			//	If there is a twin edge in reverse order.
+			if (v0->operator[](0) == pair->v1->operator[](0)
+					&&
+					v0->operator[](1) == pair->v1->operator[](1)
+					&&
+					v0->operator[](2) == pair->v1->operator[](2))
+			{
+				if (v1->operator[](0) == pair->v0->operator[](0)
+						&&
+						v1->operator[](1) == pair->v0->operator[](1)
+						&&
+						v1->operator[](2) == pair->v0->operator[](2))
+				{
+					//	Debug.
+					cout	<<	"Twin contracted (Swap)..."	<<	endl;
+
+					//	Swap.
+					aux_vert	=	pair->v0;
+					pair->v0	=	pair->v1;
+					pair->v1	=	aux_vert;
+
+					//	Active twin flag.
+					twin_found	=	true;
+				}
+			}
+		}
+
+		//	If a twin edge has been found.
+		if (twin_found)
+		{
+			//	Extract twin edge from heap.
+			top		=	heap->extract(i);
+			pair	=	(simplif::pair_info *)top->obj;
+
+			//	Copy candidate.
+			pair->candidate	=	candidate;
+
+			//	Contract twin pair.
+			do_contract(m, pair);
+			i--;
+			M0.validVertCount--;
+		}
+	}
+}
+
+//---------------------------------------------------------------------------
+//---------------------------------------------------------------------------
+simplif::real SimplificationMethod::decimate_error(simplif::Vertex *v)
+{
+	simplif::vert_info& info = vertex_info(v);
+
+	simplif::real err = simplif::quadrix_evaluate_vertex(*v, info.Q);
+
+    if( simplif::will_weight_by_area )
+		{
+			err /= info.norm;
+		}
+
+    return err;
+}
+
+//---------------------------------------------------------------------------
+//	Extract the minimum cost of the the valid nodes (not simplified)
+//---------------------------------------------------------------------------
+simplif::real SimplificationMethod::decimate_min_error()
 {
 	simplif::heap_node *top;
@@ -353,62 +724,17 @@
 	for(;;)
 	{
-		top = heap->extract();
-		if( !top ) return;
+		top = heap->top();
+		
+		if( !top )
+		{
+			return -1.0;
+		}
+
 		pair = (simplif::pair_info *)top->obj;
 
-		//Remove all the vertices of the removed edges
-		bool sharededge= false;
-		for (int i=0; i<pair->v0->edgeUses().length(); i++)
-		{		
-			simplif::Edge *econ = pair->v0->edgeUses()(i);
-			if (pair->v1->vID == econ->org()->vID || pair->v1->vID == econ->dest()->vID)
-			{
-				sharededge= true;
-				break;
-			}
-
-		}
-
-		if( pair->isValid() && sharededge)
+		if( pair->isValid() )
+		{
 			break;
-
-		delete_pair(pair);
-	}
-
-	do_contract(m, pair);
-
-	M0.validVertCount--;  // Attempt to maintain valid vertex information
-}
-
-//---------------------------------------------------------------------------
-//---------------------------------------------------------------------------
-simplif::real SimplificationMethod::decimate_error(simplif::Vertex *v)
-{
-	simplif::vert_info& info = vertex_info(v);
-
-	simplif::real err = simplif::quadrix_evaluate_vertex(*v, info.Q);
-
-    if( simplif::will_weight_by_area )
-		err /= info.norm;
-
-    return err;
-}
-
-//---------------------------------------------------------------------------
-//	Extract the minimum cost of the the valid nodes (not simplified)
-//---------------------------------------------------------------------------
-simplif::real SimplificationMethod::decimate_min_error()
-{
-	simplif::heap_node *top;
-	simplif::pair_info *pair;
-
-	for(;;)
-	{
-		top = heap->top();
-		if( !top ) return -1.0;
-		pair = (simplif::pair_info *)top->obj;
-
-		if( pair->isValid() )
-			break;
+		}
 
 		top = heap->extract();
@@ -442,49 +768,63 @@
 	int i,j;
 
-	vinfo.init(m.vertCount());
-
-	if( simplif::will_use_vertex_constraint )
-		for(i=0; i<m.vertCount(); i++)
-		{
-			simplif::Vertex *v = m.vertex(i);
-			if( v->isValid() )
+	//	Reserve memory for vert_info array.
+	vinfo.init(m.vertCount()*10);
+
+	if (simplif::will_use_vertex_constraint)
+	{
+		//	For each vertex, calculate contraints.
+		for	(i	=	0;	i < m.vertCount();	i++)
+		{
+			simplif::Vertex	*v	=	m.vertex(i);
+			
+			if (v->isValid())
+			{
 				vertex_info(v).Q = simplif::quadrix_vertex_constraint(*v);
-		}
-
-	for(i=0; i<m.faceCount(); i++)
-		if( m.face(i)->isValid() )
-		{
-			if( simplif::will_use_plane_constraint )
+			}
+		}
+	}
+
+	//	Sets the fill value of the vinfo buffer.
+	//vinfo.setFill(m.vertCount());
+
+	//	For each face, recalculate constraints.
+	for (i	=	0;	i < m.faceCount();	i++)
+	{
+		if (m.face(i)->isValid())
+		{
+			if (simplif::will_use_plane_constraint)
 			{
 				simplif::Mat4 Q = simplif::quadrix_plane_constraint(*m.face(i));
 				simplif::real norm = 0.0;
 
-				if( simplif::will_weight_by_area )
+				if (simplif::will_weight_by_area)
 				{
-					norm = m.face(i)->area();
-					Q *= norm;
+					norm	=		m.face(i)->area();
+					Q			*=	norm;
 				}
 
-				for(j=0; j<3; j++)
+				for (j	=	0;	j < 3;	j++)
 				{
-					vertex_info(m.face(i)->vertex(j)).Q += Q;
-					vertex_info(m.face(i)->vertex(j)).norm += norm;
-
+					vertex_info(m.face(i)->vertex(j)).Q			+=	Q;
+					vertex_info(m.face(i)->vertex(j)).norm	+=	norm;
 				}
 			}
 		}
-
-	if( simplif::will_constrain_boundaries )
-	{
-		for(i=0; i<m.edgeCount(); i++)
-			if( m.edge(i)->isValid() && simplif::check_for_discontinuity(m.edge(i)) )
+	}
+
+	if (simplif::will_constrain_boundaries)
+	{
+		//	For each edge, recalculate constraints.
+		for (i	=	0;	i < m.edgeCount();	i++)
+		{
+			if (m.edge(i)->isValid() && simplif::check_for_discontinuity(m.edge(i)))
 			{
 				simplif::Mat4 B = simplif::quadrix_discontinuity_constraint(m.edge(i));
 				simplif::real norm = 0.0;
 
-				if( simplif::will_weight_by_area )
+				if (simplif::will_weight_by_area)
 				{
-					norm = simplif::norm2(*m.edge(i)->org() - *m.edge(i)->dest());
-					B *= norm;
+					norm	=		simplif::norm2(*m.edge(i)->org() - *m.edge(i)->dest());
+					B			*=	norm;
 				}
 
@@ -495,12 +835,16 @@
 				vertex_info(m.edge(i)->dest()).norm += norm;
 			}
-	}
-
+		}
+	}
+
+	//	Create heap.
 	heap = new simplif::Heap(m.validEdgeCount);
 
 	int pair_count = 0;
 
-	for(i=0; i<m.edgeCount(); i++)
-		if( m.edge(i)->isValid() )
+	//	For each edge, add pairs to heap.
+	for (i	=	0;	i < m.edgeCount();	i++)
+	{
+		if (m.edge(i)->isValid())
 		{
 			simplif::pair_info *pair = new_pair(m.edge(i)->org(), m.edge(i)->dest());
@@ -509,33 +853,42 @@
 			pair_count++;
 		}
-
-	if( limit<0 )
-	{
-		limit = m.bounds.radius * 0.05;
-	}
-	proximity_limit = limit * limit;
-	if( proximity_limit > 0 )
+	}
+
+	if (limit < 0)
+	{
+		limit	=	m.bounds.radius * 0.05;
+	}
+	
+	proximity_limit	=	limit * limit;
+	
+	if (proximity_limit > 0)
 	{
 		simplif::ProxGrid grid(m.bounds.min, m.bounds.max, limit);
-		for(i=0; i<m.vertCount(); i++)
+		
+		//	Add points to grid.
+		for (i	=	0;	i < m.vertCount();	i++)
+		{
 			grid.addPoint(m.vertex(i));
+		}
 
 		simplif::buffer<simplif::Vec3 *> nearby(32);
-		for(i=0; i<m.vertCount(); i++)
+		
+		//	For each vertex.
+		for (i	=	0;	i < m.vertCount();	i++)
 		{
 			nearby.reset();
 			grid.proximalPoints(m.vertex(i), nearby);
 
-			for(j=0; j<nearby.length(); j++)
+			for (j	=	0;	j < nearby.length();	j++)
 			{
 				simplif::Vertex *v1 = m.vertex(i);
 				simplif::Vertex *v2 = (simplif::Vertex *)nearby(j);
 
-				if( v1->isValid() && v2->isValid() )
+				if (v1->isValid() && v2->isValid())
 				{
 #ifdef SAFETY
 					assert(pair_is_valid(v1,v2));
 #endif
-					if( !check_for_pair(v1,v2) )
+					if (!check_for_pair(v1,v2))
 					{
 						simplif::pair_info *pair = new_pair(v1,v2);
@@ -544,5 +897,4 @@
 					}
 				}
-
 			}
 		}
@@ -555,9 +907,7 @@
 void SimplificationMethod::simplifmethod_init(void)
 {
-	int i;
-
 	// Change mesh structure.
-	geomesh2simplifModel();
-
+	generateSimplifModel();
+		
 	M0.bounds.complete();
 
@@ -566,16 +916,22 @@
 	initialFaceCount = M0.faceCount();
 
-	// Get rid of degenerate faces
-	for(i=0; i<M0.faceCount(); i++)
-		if( !M0.face(i)->plane().isValid() )
+	// Get rid of degenerate faces.
+	for (int	i	=	0;	i < M0.faceCount();	i++)
+	{
+		if (!M0.face(i)->plane().isValid())
+		{
 			M0.killFace(M0.face(i));
+		}
+	}
 
 	M0.removeDegeneracy(M0.allFaces());
 
-	// Get rid of unused vertices
-	for(i=0; i<M0.vertCount(); i++)
-	{
-		if( M0.vertex(i)->edgeUses().length() == 0 )
+	// Get rid of unused vertices.
+	for (int	i	=	0;	i < M0.vertCount();	i++)
+	{
+		if (M0.vertex(i)->edgeUses().length() == 0)
+		{
 			M0.vertex(i)->kill();
+		}
 	}
 }
@@ -598,13 +954,23 @@
 	}
 
-	for (std::vector<MeshSimplificationSequence::Step>::iterator it= decim_data.begin(); it!=decim_data.end(); it++)
+	/*
+	for (	std::vector<MeshSimplificationSequence::Step>::iterator
+				it	=	decim_data.begin();
+				it != decim_data.end();
+				it++)
 	{
 		it->mModfaces.clear();
 	}
+	
 	decim_data.clear();
-
-	while( M0.validFaceCount > finalfaces/*simplif::face_target*/
-			&& M0.validFaceCount > 1
-			&& decimate_min_error() < simplif::error_tolerance ) 
+	*/
+
+	//	Debug.
+	cout	<<	"M0.validFaceCount: "	<<	M0.validFaceCount	<<	endl;
+	cout	<<	"finalfaces: "				<<	finalfaces				<<	endl;
+	
+	while ( M0.validFaceCount > finalfaces/*simplif::face_target*/
+					&& M0.validFaceCount > 1
+					&& decimate_min_error() < simplif::error_tolerance )
 	{
 		decimate_contract(M0);
@@ -636,5 +1002,7 @@
 	previousValidVertCount	=	0;
 
-	percent	=	(float)(2.0 * 100.0) /(float)((M0.validFaceCount - numvertices / 3.0));
+	percent	=	(float)(2.0 * 100.0)
+						/
+						(float)((M0.validFaceCount - numvertices / 3.0));
 
 	//	Update progress bar.
@@ -644,9 +1012,19 @@
 	}
 
-	for (std::vector<MeshSimplificationSequence::Step>::iterator it= decim_data.begin(); it!=decim_data.end(); it++)
+	/*
+	for (	std::vector<MeshSimplificationSequence::Step>::iterator
+				it	=	decim_data.begin();
+				it != decim_data.end();
+				it++)
 	{
 		it->mModfaces.clear();
 	}
+	
 	decim_data.clear();
+	*/
+
+	//	Debug.
+	cout	<<	"M0.validVertCount:	"	<<	M0.validVertCount	<<	endl;
+	cout	<<	"numvertices:	"	<<	numvertices	<<	endl;
 
 	while(	M0.validVertCount > numvertices	/*simplif::face_target*/
@@ -680,8 +1058,22 @@
 {
 	public:
+
 		float x,y,z;
-		_float3_(float x=0.0f, float y=0.0f, float z=0.0f){ this->x = x; this->y = y; this->z = z; }
-		_float3_(const _float3_ &f){ x=f.x; y=f.y; z=f.z; }
-		_float3_ & operator=(const _float3_ &f){ x=f.x; y=f.y; z=f.z; return *this; }
+
+		_float3_(float x=0.0f, float y=0.0f, float z=0.0f)
+		{
+			this->x = x; this->y = y; this->z = z;
+		}
+
+		_float3_(const _float3_ &f)
+		{
+			x=f.x; y=f.y; z=f.z;
+		}
+
+		_float3_ & operator=(const _float3_ &f)
+		{
+			x=f.x; y=f.y; z=f.z; return *this;
+		}
+
 		bool operator<(const _float3_ &f) const 
 		{ 
